<?php

namespace App\Classes\General\Eloquent\Filters;

use App\Classes\ValueObjects\Constants\TransactionType;
use Carbon\Carbon;
use Illuminate\Database\Eloquent\Builder;

class DoesNotHavePaymentStatusIn implements Filter
{
    /**
     * @param Builder $builder
     * @param $value
     * @return mixed
     */
    public static function apply(Builder $builder, $value)
    {
        return $builder->whereDoesntHave('transactions', function (Builder $query) use($value) {
            $query->where('type', TransactionType::PAYMENT)->whereIn('status', $value);
        });
    }
}